# PhasicFlow: interaction Class Reference

interaction Class Reference
Inheritance diagram for interaction:
[legend]
Collaboration diagram for interaction:
[legend]

## Public Types

using | IdType = typename interactionBase::IdType
using | IndexType = typename interactionBase::IndexType
using | ExecutionSpace = typename interactionBase::ExecutionSpace
Public Types inherited from interactionBase
using | IndexType = CELL_INDEX_TYPE
using | IdType = ID_TYPE
using | ExecutionSpace = DefaultExecutionSpace

## Public Member Functions

| TypeInfo ("interaction")
| interaction (systemControl &control, const particles &prtcl, const geometry &geom)
virtual | ~interaction ()=default
| create_vCtor (interaction, systemControl,(systemControl &control, const particles &prtcl, const geometry &geom),(control, prtcl, geom))
auto & | contactSearchPtr ()
auto & | contactSearchRef ()
const auto & | fileDict () const
Public Member Functions inherited from demInteraction
| demInteraction (systemControl &control)
| demInteraction (systemControl &control, const fileSystem &file)
Public Member Functions inherited from property
| TypeInfoNV ("property")
| Type info. More...
| property ()
| Emptry constructor, used for reading from a file. More...
| property (const wordVector &materials, const realVector &densities)
| Constructe from materials and densities. More...
| property (const fileSystem &file)
| Construct from file. More...
| property (const dictionary &dict)
| Construct from dictionary dict. More...
| property (const property &)=default
| Default copy. More...
| property (property &&)=default
| Default move. More...
property & | operator= (const property &)=default
| Default copy assignment. More...
property & | operator= (property &&)=default
| Default move assignment. More...
| ~property ()=default
| Default destructor. More...
const auto & | dict () const
| Return dictionary. More...
auto | numMaterials () const
| Return number of materials. More...
const auto & | materials () const
| Return list of material names. More...
const auto & | densities () const
| Return the list of densities. More...
const word & | material (uint32 i) const
| Return the material name of material i. More...
bool | material (uint32 i, word &name) const
| Get the name of material i. More...
real | density (uint32 i) const
| Return density of material i. More...
bool | density (uint32 i, real &rho) const
| Get the density of material i. More...
bool | nameToIndex (const word &name, uint32 &idx) const
| Get the name of material in index idx Return true, if the name found, otherwise false. More...
bool | read (const dictionary &dict)
| Read from dictionary. More...
bool | write (dictionary &dict) const
| Write to dictionary. More...
Public Member Functions inherited from demComponent
| TypeInfo ("demComponent")
| demComponent (const word &name, systemControl &control)
virtual | ~demComponent ()=default
const auto & | control () const
auto & | control ()
real | dt () const
real | currentTime () const
auto & | timers ()
const auto & | timers () const
virtual bool | beforeIteration ()=0
virtual bool | iterate ()=0
virtual bool | afterIteration ()=0
Public Member Functions inherited from eventObserver
| eventObserver ()
| eventObserver (const eventSubscriber &subscriber, bool subscribe=true)
virtual | ~eventObserver ()
bool | subscribed () const
bool | subscribe (const eventSubscriber &subscriber)
void | invalidateSubscriber ()
virtual bool | update (const eventMessage &msg)=0
Public Member Functions inherited from interactionBase
| interactionBase (const particles &prtcl, const geometry &geom)
const auto & | pStruct () const
const auto & | surface () const
const auto & | Particles () const
auto & | Geometry () const

## Static Public Member Functions

static uniquePtr< interaction > | create (systemControl &control, const particles &prtcl, const geometry &geom)

## Protected Attributes

dictionary & | fileDict_
| interaction file dictionary More...
uniquePtr< contactSearch > | contactSearch_ = nullptr
| contact search object for pp and pw interactions More...
Protected Attributes inherited from property
uniquePtr< dictionary > | dict_ = nullptr
| pointer to the dictionary, if it is constructed from a file/dictionary More...
wordVector | materials_
| list of name of materials More...
realVector | densities_
| list of density of materials More...
wordHashMap< uint32 > | nameIndex_
| rapid mapping from name to index More...
uint32 | numMaterials_ = 0
| number of materials More...
Protected Attributes inherited from demComponent
word | componentName_
systemControl & | control_
Timers | timers_
Protected Attributes inherited from eventObserver
const eventSubscriber * | subscriber_ = nullptr
bool | subscribed_ = false
Protected Attributes inherited from interactionBase
const particles & | particles_
const geometry & | geometry_

## Additional Inherited Members

Protected Member Functions inherited from property
bool | readDictionary (const dictionary &dict)
| read from dict More...
bool | writeDictionary (dictionary &dict) const
| write to dict More...
bool | makeNameIndex ()
| creates a mapp More...

## Detailed Description

Definition at line 34 of file interaction.hpp.

## Member Typedef Documentation

## IdType

using IdType = typename interactionBase::IdType

Definition at line 42 of file interaction.hpp.

## IndexType

using IndexType = typename interactionBase::IndexType

Definition at line 44 of file interaction.hpp.

## ExecutionSpace

using ExecutionSpace = typename interactionBase::ExecutionSpace

Definition at line 46 of file interaction.hpp.

## Constructor & Destructor Documentation

## interaction()

interaction | ( | systemControl & | control,
|  | const particles & | prtcl,
|  | const geometry & | geom
| ) |  |

Definition at line 25 of file interaction.cpp.

References particles::pStruct().

Here is the call graph for this function:

## ~interaction()

virtual ~interaction | ( |  | ) |

virtualdefault

## Member Function Documentation

## TypeInfo()

TypeInfo | ( | "interaction" |  | ) |

## create_vCtor()

create_vCtor | ( | interaction | ,
|  | systemControl | ,
|  | (systemControl &control, const particles &prtcl, const geometry &geom) | ,
|  | (control, prtcl, geom) |
| ) |  |

## contactSearchPtr()

auto& contactSearchPtr | ( |  | ) |

inline

Definition at line 83 of file interaction.hpp.

References interaction::contactSearch_.

## contactSearchRef()

auto& contactSearchRef | ( |  | ) |

inline

Definition at line 88 of file interaction.hpp.

References interaction::contactSearch_.

## fileDict()

const auto& fileDict | ( |  | ) | const

inline

Definition at line 93 of file interaction.hpp.

References interaction::fileDict_.

## create()

pFlow::uniquePtr< pFlow::interaction > create | ( | systemControl & | control,
|  | const particles & | prtcl,
|  | const geometry & | geom
| ) |  |

static

Definition at line 56 of file interaction.cpp.

References pFlow::angleBracketsNames(), pFlow::angleBracketsNames3(), systemControl::caseSetup(), endREPORT, fatalError, fatalExit, dictionary::getVal(), greenText, pFlow::interactionFile__, geometry::motionModelTypeName(), repository::path(), pFlow::printKeys(), REPORT, particles::shapeTypeName(), and dictionary::subDict().

Here is the call graph for this function:

## Member Data Documentation

## fileDict_

dictionary& fileDict_

protected

interaction file dictionary

Definition at line 51 of file interaction.hpp.

Referenced by interaction::fileDict().

## contactSearch_

uniquePtr<contactSearch> contactSearch_ = nullptr

protected

contact search object for pp and pw interactions

Definition at line 54 of file interaction.hpp.

Referenced by interaction::contactSearchPtr(), interaction::contactSearchRef(), and sphereInteraction< contactForceModel, geometryMotionModel, contactListType >::iterate().

The documentation for this class was generated from the following files:

- src/Interaction/interaction/interaction.hpp
- src/Interaction/interaction/interaction.cpp